
var ff14_api = '/ff14/api/?';
var ff14_imagebase = ff14_api+'d=image&f=bgimage.';
var ff14_lds = {
	'jp':'http://jp.finalfantasyxiv.com/lodestone/',
	'en':'http://na.finalfantasyxiv.com/lodestone/'
};
var tabId = '#tabs';
var chartIdName = 'ChartDivs';
var chartId = '#'+chartIdName;
var searchIdName = 'mysearchDivs';
var searchId = '#'+searchIdName;
var mylistIdName = 'mylistTable';
var mylistId = '#'+mylistIdName;
var dtlIdName = 'dtlDivs';
var dtlId = '#'+dtlIdName;
var req_old = { 'tab': '-', 'sel1': '-', 'sel2':'-' };
var req_new = { 'tab': '-', 'sel1': '-', 'sel2':'-' };
var chartArea;
var msgblink;
var ajaxdata;
var ajax_timeout = 30;
var x;



$(document).ready(function(){
	bgslide();
	chartCreate();
	pagectl('');
	$( tabId ).tabs({
		collapsible: true,
		active: false,
		activate: function(event,ui){
			req_old['tab'] = req_new['tab'];
			req_old['sel1'] = req_new['sel1'];
			req_old['sel2'] = req_new['sel2'];
			req_new['tab'] = ui.newPanel.attr('id');
			req_new['sel1'] = $('#'+req_new['tab']+'sel1').val();
			req_new['sel2'] = $('#'+req_new['tab']+'sel2').val();
			pagectl(req_new['tab']);
			if (req_new['tab']=='tab1') { chartLoad(); }
		}
	});
	$('#tab1sel1').change(function () {
		req_old['sel1'] = req_new['sel1'];
		req_new['sel1'] = $('#tab1sel1 option:selected').val();
		chartLoad();
	}).change();
	$('#tab1sel2').change(function () {
		req_old['sel2'] = req_new['sel2'];
		req_new['sel2'] = $('#tab1sel2 option:selected').val();
		chartLoad();
	}).change();
	$('#tab3sel1').change(function () {
		req_old['sel1'] = req_new['sel1'];
		req_new['sel1'] = $('#tab3sel1 option:selected').val();
		switch(req_new['sel1']){
		case '501': $('#tab3dtl1').show(); $('#tab3dtl2').hide(); ff14font(); break;
		case '101': case '102': case '103': case '201': case '202':
			$('#tab3dtl1').hide(); $('#tab3dtl2').hide(); legacyimg(req_new['sel1']); break;
		default: $('#tab3dtl1').hide(); $('#tab3dtl2').hide();
		}
	}).change();
	$( '#srcbtn' ).button().click(function(){search_event();});
	$('input[name="bgsize"]:radio').change(function(){bgslide();});

});

function bgslide(){
	$.backstretch('destroy',false);
	var bgimg = [];
	var bgimg_max = 200;
	var bgimg_load = 20;
	var opt = {duration: 30*1000, fade: 900, timeout:0 };
	var n = Math.floor( Math.random()*(bgimg_max-bgimg_load) );
	var size = $('input[name="bgsize"]:checked').val();
	for(var i=0;i<bgimg_load;i++){ bgimg.push(ff14_imagebase+String(i+n)+'&'+size); }

	var bgimg_init = 1;
	var bgimg_p = [];
	for(i=0;i<bgimg_init;i++){ bgimg_p.push(bgimg[i]); }
	$.backstretch( bgimg_p, opt );
	var ins = $('body').data('backstretch');
	for(;i<bgimg_load;i++){ ins.images.push(bgimg[i]); }
}


function pagectl(tab){
	var ids = { 'tab1':[chartId], 'tab2':[searchId, dtlId], 'tab3':['#tab3dtl1', '#tab3dtl2'] };
	for(j in ids){
		for(var i=0;i<ids[j].length;i++){ $(ids[j][i]).hide(); }
	}
	switch(tab){
	case 'tab3':
		var q = $('#tab3sel1 option:selected').val();
		switch(q){
		case '501':	$(ids[tab][0]).show(); break;
		default:	$(ids[tab][1]).show();
		}
		break;
	default:	$(ids[tab]).show();
	}
}

function myajax(urls,succ,err){
	$.ajax({
		url: ( urls ),
		data: '{}',
		type: 'GET',
		timeout: ajax_timeout*1000,
		cache: false,
		contentType: 'application/json; charset=utf-8',
		dataType : 'json',
		error: err,
		success: succ
	});
}


////////////////////// chart  //////////////////////////////

function chartCreate(){
	chartArea = new cfx.Chart();
	chartArea.getData().setSeries(1);
	chartArea.getSeries().getItem(0).setGallery(cfx.Gallery.Bar);
	chartArea.create(chartIdName);
//	$(chartId).hide();
}


function chartLoad(){
	var $btn = { '501':false, '801':false, '802':false, '803':false, '804':false, '811':false, '812':false, '821':false }
	if (	(req_old['tab']==req_new['tab']) &&
		(req_old['sel1']==req_new['sel1']) &&
		(req_old['sel2']==req_new['sel2'])
		) { return; }
	if (req_new['tab']!='tab1'){ return; }
	if ((req_new['sel1'] in $btn)===true){
		if ($btn[req_new['sel1']]){
			$('#tab1sel2').removeAttr('disabled');
		} else {
			$('#tab1sel2').attr('disabled','disabled');
		}
	}
	urls = ff14_api+'r='+'sta'+'&id='+req_new['sel1'];
	myajax(urls,chartLoad_success,chartLoad_error);
	$(chartId).show();
}

function chartLoad_error(xhr, txt, err) {
	alert('error connecting to data: ' + txt);
}

function chartLoad_success(result) {
	switch(req_new['tab']){
	case 'tab1': tab1chart(result,req_new['sel1']); break;
	default: return;
	}

	var td = new cfx.TitleDockable();
	td.setText(result.title_ja+' ('+result.date+')');
	td.setRichText(true);
	chartArea.getTitles().removeAt();
	chartArea.getTitles().add(td);
}

function tab1chart(result,sel1){
//	chartArea.setGallery(cfx.Gallery.Gantt);
	chartArea.setGallery(cfx.Gallery.Bar);
	chartArea.getAxisX().setStep(1);
	chartArea.getAxisX().setLabelAngle(75);
//	chartArea.getAxisX().setAutoScale(false);
//	chartArea.getAxisX().setStaggered(true);
	var m = result.item;
	switch(sel1){
	case '801':
		chartArea.getData().setSeries(1);
		chartArea.getLegendBox().setVisible(false);
		break;
	case '802':
		chartArea.getData().setSeries(2);
		chartArea.getAllSeries().setStacked(cfx.Stacked.Normal);
		chartArea.getLegendBox().setVisible(true);
		break;
	case '803':
		chartArea.getData().setSeries(5);
		chartArea.getAllSeries().setStacked(cfx.Stacked.Normal);
		chartArea.getLegendBox().setVisible(true);
		break;
	case '804':
		chartArea.getData().setSeries(10);
		chartArea.getAllSeries().setStacked(cfx.Stacked.Normal);
		chartArea.getLegendBox().setVisible(true);
		break;
	case '811':
		chartArea.getData().setSeries(2);
		chartArea.getAllSeries().setStacked(cfx.Stacked.Normal);
		chartArea.getLegendBox().setVisible(true);
		break;
	case '812':
		chartArea.getData().setSeries(6);
		chartArea.getAllSeries().setStacked(cfx.Stacked.Normal);
		chartArea.getLegendBox().setVisible(true);
//		var legendItem;
//		legendItem = new cfx.CustomLegendItem();
//		legendItem.setText("FC加入数");
//		chart1.getLegendBox().getCustomItems().add(legendItem);
		break;
	case '821':
		chartArea.getData().setSeries(4);
		chartArea.getAllSeries().setStacked(cfx.Stacked.Normal);
		chartArea.getLegendBox().setVisible(true);
		break;
	case '501':
		chartArea.getData().setSeries(2);
		chartArea.getAllSeries().setStacked(cfx.Stacked.Normal);
		chartArea.getLegendBox().setVisible(false);
		break;
	}
	chartArea.setDataSource(m);
//var a=new cfx.CustomLegendItem();
//a.setColor("#f0f0f0");
//a.setAttributes(chartArea.getPoints().getItem(0,5));
}



////////////////////// search //////////////////////////////

function search_event(){
	$(dtlId).hide();
	$(searchId).show();
	var t1 = $('#tab2sel1').val();
	var t2 = $('#tab2sel2').val();
	var t3 = $('#tab2input').val();
	var urls = '';
	var src_a = { '101':'c', '102':'f', '103':'l' };
	urls = ff14_api+'r='+src_a[t1];
	switch(t2){
	case '101': urls += '&name='+t3+''; break;
	case '102': urls += '&name='+t3+'*'; break;
	case '103': urls += '&name=*'+t3+'*'; break;
	case '104': urls += '&name=*'+t3+''; break;
	}
	
	charlist_reset(8);
	status_msg('start','search');

	switch(t1){
	case '101': myajax(urls,charlist_done,charlist_fail); break;
	case '102': myajax(urls,freelist_done,charlist_fail); break;
	case '103': myajax(urls,linklist_done,charlist_fail); break;
	}
}

function status_msg(stat,msg){
	switch(stat){
	case 'start':
		$('#listmsg').html(msg);
		msgblink = setInterval(function(){  
			$('#listmsg').fadeOut(500,function(){$(this).fadeIn(500)}); 
		},1200); 
		break;
	case 'stop':
		clearInterval(msgblink); 
		$('#listmsg').html(msg);
		break;
	case 'show':
		$('#listmsg').text(msg);
		break;
	}
}

function charlist_fail(xhr,status,error) {
	switch(status){
	case 'timeout': msg = 'too many records  or  server busy '; break;
	default: msg = 'error connecting to data: ' + status;
	}
	var t1 = $('#tab2sel1').val();
	if (t1=='102') { msg='FC検索は構築中です'; }
	if (t1=='103') { msg='LS検索は構築中です'; }
	status_msg('stop',msg);
}

function charlist_reset(dt_ct){
	var sData = []; var aCol = [];
	for( var j=0;j<dt_ct;j++){
		sData.push( '' ); aCol.push( { 'sTitle':'' } );
	}
	$(mylistId).dataTable({ 'bDestroy':true, 'aaData':[sData], 'aoColumns':aCol });
}

function charlist_done(result,status,xhr) {
//	var ilist = [ 
//'id','firstname','lastname','server','syu1','syu2','syu3','birth','guard_name','start_city_name',
//'gcname','gclank','fcname','fid','message','gladiatorlevel','pugilistlevel','marauderlevel',
//'lancerlevel','archerlevel','conjurerlevel','thaumaturgelevel','arcanistlevel','carpenterlevel',
//'blacksmithlevel','armorerlevel','goldsmithlevel','leatherworkerlevel','weaverlevel',
//'alchemistlevel','culinarianlevel','minerlevel','botanistlevel','fisherlevel','check_datetime'
//	];
	var ilist = [ 'firstname','lastname','server','syu1','syu2','syu3','fcname', 'id' ];
	var vlist = [ 0,1,1,1,1,1,1,1 ];
	var aCol = [];
	for( var j=0;j<ilist.length;j++){
		aCol.push( { 'sTitle':ilist[j] } );
	}
	var m = result.item;
	var sData = [];
	for( var i=0;i<result.count;i++){
		var q = [];
		for( var j=0;j<ilist.length;j++){ q.push(m[i][ilist[j]]); }
		sData.push( q );
	}
	var xx = $(mylistId).dataTable({ 'bDestroy':true, 'aaData':sData, 'aoColumns':aCol });
	$(xx.fnGetNodes()).on('click',char_history_dtl);
	ajaxdata = $.extend(true,{},result);

	var msg = '';
	status_msg('stop',msg);
	if (result.maxcount!=result.count){
		msg = result.maxcount+'件中'+result.count+'件を表示しています';
	}
	if (result.count==0){ msg = '見つかりません'; }
	status_msg('show',msg);
}

function char_history_dtl(){
	$(searchId).hide();
	$(dtlId).html('');
	if (('innerText' in this.cells[7])===true){	// innerText Not define FireFox
		var id = this.cells[7].innerText;
	} else {
		var id = this.cells[7].textContent;
	}
	var s = {};
	for(i in ajaxdata.item){
		if (('id' in ajaxdata.item[i])===false){ continue; }
		if (ajaxdata.item[i]['id']==id){ s = ajaxdata.item[i]; break; }
	}
	var x = '';
	if (('id' in s)===false){
		x = 'unknown';
		$(dtlId).html(x);
		$(dtlId).show();
		return;
	}
	x += '<div id="his_dtl" class="boxshadow">';
//	x += '<div id="his_left"><img src="'+s['iconurl']+'" width="64px" /></div>';
	x += '<div id="his_right"><table>';
	var mlist = { 
		'firstname':true, 'server':false, 'iconurl':true, 
		'syu1':'race', 'syu2':'tribe', 'syu3':'gender', 'start_city_name':'city', 
		'gcname':'gc', 'gclank':'rank', 'fcname':false, 'check_datetime':'date'
	};
	for(i in s){
		if ((i in mlist)===false){ continue; }
		if (mlist[i]===false){
			x += '<tr><td>'+i+':</td><td>'+s[i]+'</td></tr>';
		} else if (mlist[i]!==true){
			x += '<tr><td>'+mlist[i]+':</td><td>'+s[i]+'</td></tr>';
		} else {
			switch(i){
			case 'firstname':
				x += '<tr><td>'+'name'+':</td><td>'+s['firstname']+' '+s['lastname']+'</td></tr>';
				break;
			case 'iconurl':
				x += '<tr><td colspan=2 align=center><img src="'+s[i]+'" width="64px" /></td></tr>';
				break;
			default:
			}
		}
	}
	var nurl = "window.open('"+ff14_lds['jp']+"character/"+s['id']+"/','');return false;";
	x += '<tr><td colspan=2 align=center><button onclick="'+nurl+'" title="Official Home" ><img src="/ff14/api/?d=image&f=ff14lds.ico" /></button></td></tr>';
	x += '<tr><td colspan=2 align=center><button onclick="retdtl();">return to list</button></td></tr>';
	x += '</table></div>';
	x += '<div id="fc_history" class="boxshadow"></div>';
	x += '<div id="level_history" class="boxshadow"></div>';
	x += '</div>';
	$(dtlId).html(x);
	$(dtlId).show();
	var q = '<table>';
	q += '<caption>SERVER/FC HISTORY</caption>';
	q += '<tr><td colspan=5 align=center><img src="/ff14/api/?d=image&f=006.gif" width=32></td></tr>'
		+'</table>';
	$('#fc_history').html(q);

	var url = ff14_api+'r=c&s=fc&id='+s.id;
	myajax(url,char_fc_history_done,char_fc_history_fail);

	var q = '<table>';
	q += '<caption>LEVEL HISTORY</caption>';
	q += '<tr><td colspan=5 align=center><img src="/ff14/api/?d=image&f=006.gif" width=32></td></tr>'
		+'</table>';
	$('#level_history').html(q);

	var url = ff14_api+'r=c&s=level&id='+s.id;
	myajax(url,char_level_history_done,char_level_history_fail);

}

function char_fc_history_fail(){
	var q = '<table>';
	q += '<caption>SERVER/FC HISTORY</caption>';
	q += '<tr><td align=center>server busy</td></tr>';
	q += '</table>';
	$('#fc_history').html(q);
}

function char_fc_history_done(result,status,xhr){
	var q = '<table>';
	q += '<caption>SERVER/FC HISTORY</caption>';
	q += '<tr><td>server</td><td>fc</td><td>date</td></tr>';
	for(i=0;i<result.count;i++){
		var u = result.item[i];
		if (('sv' in u)===false) { continue; }
		q += '<tr><td>'+u['sv']+'</td><td>';
		if (u['fc']==''){q+='---'}else{q+=u['fc']}
		q += '</td><td>'+u['cd']+'</td></tr>';
	}
	q += '</table>';
	$('#fc_history').html(q);
}

function char_level_history_fail(){
	var q = '<table>';
	q += '<caption>LEVEL HISTORY</caption>';
	q += '<tr width=200><td align=center>server busy</td></tr>';
	q += '</table>';
	$('#level_history').html(q);
}

function char_level_history_done(result,status,xhr){
	var q = '<table>';
	q += '<caption>LEVEL HISTORY</caption>';
	q += '<tr><td>server</td>';
	for(i=1;i<20;i++){
		q += '<td><img src="/ff14/api/?d=image&f='+'j'+String(i)+'.png" width=16 height=16 /></td>';
	}
	q += '<td>date</td></tr>';
	for(i=0;i<result.count;i++){
		var u = result.item[i];
		if (('sv' in u)===false) { continue; }
		q += '<tr>';
		for(j in u){ q += '<td align=center>'+u[j]+'</td>'; }
		q += '</tr>';
	}
	q += '</table>';
	$('#level_history').html(q);
}

function retdtl(){
	$(dtlId).hide();
	$(searchId).show();
}


/////////////// fc ///////////

function freelist_done(result,status,xhr) {
//"fid","fcname","fctag","server_name","gcname","gclank","member_ct","message",
//"create_datetime","delete_date","check_datetime"
	var ilist = [ 'fcname','fctag','server_name','gcname','gclank','member_ct','message', 'fid' ];
	var vlist = [ 0,1,1,1,1,1,1,1 ];
	var aCol = [];
	for( var j=0;j<ilist.length;j++){
		aCol.push( { 'sTitle':ilist[j] } );
	}
	var m = result.item;
	var sData = [];
	for( var i=0;i<result.count;i++){
		var q = [];
		for( var j=0;j<ilist.length;j++){ q.push(m[i][ilist[j]]); }
		sData.push( q );
	}
	var xx = $(mylistId).dataTable({ 'bDestroy':true, 'aaData':sData, 'aoColumns':aCol });
	$(xx.fnGetNodes()).on('click',free_history_dtl);
	ajaxdata = $.extend(true,{},result);

	status_msg('stop','');
	if (result.count==0){
		status_msg('show','見つかりません');
	} else 
	if (result.maxcount==result.count){
		status_msg('show','');
	} else {
		status_msg('show',result.maxcount+'件中'+result.count+'件を表示しています');
	}
}

function free_history_dtl(){
	$(searchId).hide();
	$(dtlId).html('');
	if (('innerText' in this.cells[7])===true){	// innerText Not define FireFox
		var id = this.cells[7].innerText;
	} else {
		var id = this.cells[7].textContent;
	}
	var s = {};
	for(i in ajaxdata.item){
		if (('fid' in ajaxdata.item[i])===false){ continue; }
		if (ajaxdata.item[i]['fid']==id){ s = ajaxdata.item[i]; break; }
	}
	var x = '';
	if (('fid' in s)===false){
		x = 'unknown';
		$(dtlId).html(x);
		$(dtlId).show();
		return;
	}
	x += '<div id="his_dtl" class="boxshadow">';
//	x += '<div id="his_left"><img src="'+s['iconurl']+'" width="64px" /></div>';
	x += '<div id="his_right"><table>';
	var mlist = { 
		'fcname':'DATA','fctag':'DATA','server_name':'DATA','gcname':'DATA','gclank':'DATA',
		'member_ct':'DATA','message':'DATA','create_datetime':'DATA','delete_date':'DATA',
		'check_datetime':'DATA'
	};
	for(i in s){
		if ((i in mlist)===false){ continue; }
		if (mlist[i]===false){
			x += '<tr><td>'+i+':</td><td>'+s[i]+'</td></tr>';
		} else if (mlist[i]!==true){
			x += '<tr><td>'+mlist[i]+':</td><td>'+s[i]+'</td></tr>';
		} else {
			switch(i){
			case 'firstname':
				x += '<tr><td>'+'name'+':</td><td>'+s['firstname']+' '+s['lastname']+'</td></tr>';
				break;
			case 'iconurl':
				x += '<tr><td colspan=2 align=center><img src="'+s[i]+'" width="64px" /></td></tr>';
				break;
			default:
			}
		}
	}
	var nurl = "window.open('"+ff14_lds['jp']+"freecompany/"+s['uid']+"/','');return false;";
	x += '<tr><td colspan=2 align=center><button onclick="'+nurl+'" title="Official Home" ><img src="/ff14/api/?d=image&f=ff14lds.ico" /></button></td></tr>';
	x += '<tr><td colspan=2 align=center><button onclick="retdtl();">return to list</button></td></tr>';
	x += '</table></div>';
	x += '<div id="fc_history" class="boxshadow"></div>';
	x += '<div id="level_history" class="boxshadow"></div>';
	x += '</div>';
	$(dtlId).html(x);
	$(dtlId).show();
	var q = '<table>';
	q += '<caption>SERVER/FC HISTORY</caption>';
	q += '<tr><td colspan=5 align=center><img src="/ff14/api/?d=image&f=006.gif" width=32></td></tr>'
		+'</table>';
	$('#fc_history').html(q);

//	var url = ff14_api+'r=f&s=fc&id='+s.fid;
//	myajax(url,fc_member_history_done,fc_member_history_fail);

//	var q = '<table>';
//	q += '<caption>LEVEL HISTORY</caption>';
//	q += '<tr><td colspan=5 align=center><img src="/ff14/api/?d=image&f=006.gif" width=32></td></tr>'
//		+'</table>';
//	$('#level_history').html(q);
//
//	var url = ff14_api+'r=c&s=level&id='+s.id;
//	myajax(url,char_level_history_done,char_level_history_fail);

}




/////////////// ls ///////////

function linklist_done(result,status,xhr) {
}



//////////////////

function legacyimg(t){
	var q = {
		'101':{'a':'v1ss','b':'FF14 Legacy / SS'},
		'102':{'a':'v1job','b':'FF14 Legacy / job image'},
		'103':{'a':'v1other','b':'FF14 Legacy / images'},
		'201':{'a':'v2preview','b':'FF14 / preview'},
		'202':{'a':'v2concept','b':'FF14 / concept art'},
		'':{'a':'v1ss','b':'FF14 Legacy / SS'}
	}
	var toptag = 'tab3dtl2';
	var topid = 'legacyimgtop';
	$('#'+toptag).html('');
	var u = ' id="'+topid+'" ';
	var ss = 50;
	var r = Math.floor( Math.random()*(999-ss) );
	for(var i=r;i<(r+ss);i++){
		var a = '<a href="/ff14/api/?d=image&f='+q[t]['a']+'.'+String(i)
			+'" class="ajax-popup-link" '+u+'></a>';
		$('#'+toptag).append(a);
		u = '';
	}
	$('#'+toptag).magnificPopup({ 
		type: 'image',
		delegate: 'a',
		gallery:{enabled:true,preload:[0,2]},
		image:{ titleSrc:q[t]['b'] },
		callbacks: {
			buildControls: function() {
				this.contentContainer.append(this.arrowLeft.add(this.arrowRight));
			}
		}
	});
	$('#'+topid).trigger('click');
}


function ff14font(){
	urls = '/ff14/ff14font/?s=';
	myajax(urls,function(result){
		var seed = result;
	},'');
}




